# -*- coding: utf-8 -*-

# Copyright (C) 2007-2014 Avencall
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>

import unittest
from xivo_cti.tools.idconverter import IdConverter


class TestIdConverter(unittest.TestCase):

    def test_xid_to_id_input_empty(self):
        identifier = ''
        expected_result = None

        result = IdConverter.xid_to_id(identifier)

        self.assertEqual(result, expected_result)

    def test_xid_to_id_input_int(self):
        identifier = 12
        expected_result = '12'

        result = IdConverter.xid_to_id(identifier)

        self.assertEqual(result, expected_result)

    def test_xid_to_id_input_id(self):
        identifier = '12'
        expected_result = '12'

        result = IdConverter.xid_to_id(identifier)

        self.assertEqual(result, expected_result)

    def test_xid_to_id_input_xid(self):
        identifier = 'ipbxid/12'
        expected_result = '12'

        result = IdConverter.xid_to_id(identifier)

        self.assertEqual(result, expected_result)

    def test_xid_to_id_None(self):
        identifier = None
        expected_result = None

        result = IdConverter.xid_to_id(identifier)

        self.assertEqual(result, expected_result)
